var GUMForm =
{
  parentDomain: null,
  startTime: null,
  isDivi : false,
  noRedirect: false,
  data : {},
  form : null,
  currentStep : 0,
  editIsActive: false,
  isSending : false,
  phoneNumber: null,
  phoneVerified: false,
  stepCount : null,
  excluded_clients : null,
  baseApiDomain: null,
  baseApiUrl: null,
  patterns :
  {
    "first_name" : /^[A-zÀ-ÿ \-,']{2,30}$/i,
    "last_name" : /^[A-zÀ-ÿ \-,']{2,30}$/i,

    "phone" :
    {
      "fr" : /^(?:(?:\+|00)33[\s.-]{0,3}(?:\(0\)[\s.-]{0,3})?|0)[1-9](?:(?:[\s.-]?\d{2}){4}|\d{2}(?:[\s.-]?\d{3}){2})$/i,
      "es" : /^(\+34 *)*[0-9]{3} *[0-9]{2} *[0-9]{2} *[0-9]{2}$/i,
      "pt" : /^(\+351 *)?(([0-9]{2} *[0-9]{3} *[0-9]{4})|([0-9]{3} *[0-9]{3} *[0-9]{3}))$/i,
      "gb" : /^(\s*\(?(0|\+44)(\s*|-)\d{4}\)?(\s*|-)\d{3}(\s*|-)\d{3}\s*)|(\s*\(?(0|\+44)(\s*|-)\d{3}\)?(\s*|-)\d{3}(\s*|-)\d{4}\s*)|(\s*\(?(0|\+44)(\s*|-)\d{2}\)?(\s*|-)\d{4}(\s*|-)\d{4}\s*)|(\s*(7|8)(\d{7}|\d{3}(\-|\s{1})\d{4})\s*)|(\s*\(?(0|\+44)(\s*|-)\d{3}\s\d{2}\)?(\s*|-)\d{4,5}\s*)$/i,
      "us" : /^\+*1* *\(*[0-9]{3}\)*-*[0-9]{3}-*[0-9]{4}$/i,
      "au" : /^[\+|0]61 *[0-9]{1} *[0-9]{4} *[0-9]{4}$/i,
      "it" : /^(\+39 *)*[0-9]{3} *[0-9]{2} *[0-9]{2} *[0-9]{2,3}$/i,
      "ch": /^(0|\+41|0041)? ?\d\d ?\d\d\d ?\d\d ?\d\d$/i,
      "de": /^(0|\+49|0049) ?\d{3,4} ?\d{7}$/i
    },

    "email" : /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/i,
    "address": /[a-zA-ZÀ-ÿ0-9 \-,']/i,
    "city": /[a-zÀ-ÿA-Z \-,']/i,
    "DestinationAddress": /[a-zA-ZÀ-ÿ0-9 \-,']/i,
    "DestinationCity": /[a-zÀ-ÿA-Z \-,']/i,
    "province": /[a-zÀ-ÿA-Z \-,']/i,

    "VIN": /[(A-H|J-N|P|R-Z|0-9)]{17}/i, // vehicle identification number

    "Comment": /.{0,500}/i,

    "zip":
    {
      "fr" : /^[0-9]{5}$/i,
      "de" : /^[0-9]{5}$/i,
      "es" : /^[0-9]{5}$/i,
      "pt" : /^\d{4}(-\d{3})?$/i,
      "gb" : /^([Gg][Ii][Rr] 0[Aa]{2})|((([A-Za-z][0-9]{1,2})|(([A-Za-z][A-Ha-hJ-Yj-y][0-9]{1,2})|(([A-Za-z][0-9][A-Za-z])|([A-Za-z][A-Ha-hJ-Yj-y][0-9][A-Za-z]?))))\s?[0-9][A-Za-z]{2})$/i,
      "us" : /^[0-9]{5}(?:-[0-9]{4})?$/i,
      "au" : /^(0[289][0-9]{2})|([1345689][0-9]{3})|(2[0-8][0-9]{2})|(290[0-9])|(291[0-4])|(7[0-4][0-9]{2})|(7[8-9][0-9]{2})$/i,
      "it" : /^[0-9]{5}$/i,
      "ch" : /^[0-9]{4}$/i,
    },

    "DestinationZipCode":
    {
      "fr" : /^[0-9]{5}$/i,
      "de" : /^[0-9]{5}$/i,
      "es" : /^[0-9]{5}$/i,
      "pt" : /^\d{4}(-\d{3})?$/i,
      "gb" : /^([Gg][Ii][Rr] 0[Aa]{2})|((([A-Za-z][0-9]{1,2})|(([A-Za-z][A-Ha-hJ-Yj-y][0-9]{1,2})|(([A-Za-z][0-9][A-Za-z])|([A-Za-z][A-Ha-hJ-Yj-y][0-9][A-Za-z]?))))\s?[0-9][A-Za-z]{2})$/i,
      "us" : /^[0-9]{5}(?:-[0-9]{4})?$/i,
      "au" : /^(0[289][0-9]{2})|([1345689][0-9]{3})|(2[0-8][0-9]{2})|(290[0-9])|(291[0-4])|(7[0-4][0-9]{2})|(7[8-9][0-9]{2})$/i,
      "it" : /^[0-9]{5}$/i,
      "ch" : /^[0-9]{4}$/i,
    },

    "Birthday": new RegExp(`^(0[1-9]|1[0-9]|2[0-9]|3[0-1])\\/(0[1-9]|1[0-2])\\/(19[0-9]{2}|20[0-1][0-9]|202[0-${new Date().getFullYear().toString().slice(-1)}])$`),
    "BirthYear": new RegExp(`^(19[0-9]{2}|20[0-1][0-9]|202[0-${new Date().getFullYear().toString().slice(-1)}])$`),

    // those are "sub"-input to build the Birthday field, not sent to the API
    "gum-day" : /^(0?[1-9]|[12][0-9]|3[01])$/,
    "gum-month" : /^(0?[1-9]|1[0-2])$/,
    "gum-year" : new RegExp(`^(19[0-9]{2}|20[0-1][0-9]|202[0-${new Date().getFullYear().toString().slice(-1)}])$`),
  },
  contact_fields:[
    "first_name", "last_name", "email", "phone", "zip", "address", "city"
  ],

  isValid : function(step)
  {
    var errorCount = 0;

    // verifying text inputs
    var elements = step.querySelectorAll("input[type='text'],input[type='number'],input[type='tel'],input[type='email'],input[type='date']"),
        form = step.closest("div.gum-form");

    if(elements != null)
    {
      elements.forEach(function(element)
      {
        var pattern = GUMForm.patterns[element.name], regex;

        // a date input just need to be not empty
        if(element.type == "date")
        {
          if(element.value != "")
          {
            GUMForm.data[element.name] = element.value;
            element.classList.remove("gum-error");
          }

          else
          {
            element.classList.add("gum-error");
            errorCount++;
          }
        }

        // for the others, pattern verification
        else if(pattern != undefined)
        {
          // certain regex are different according to the country (zip, phone etc)
          if(pattern.constructor.name == "Object") regex = pattern[form.getAttribute("gum-country")];
          else regex = pattern;

          if(element.value.match(regex))
          {
            if(element.name.indexOf("gum-") == -1) GUMForm.data[element.name] = element.value;
            element.classList.remove("gum-error");
          }

          else
          {
            element.classList.add("gum-error");
            errorCount++;
          }
        }

        else
        {
          element.classList.remove("gum-error");
          GUMForm.data[element.name] = element.value;
        }
      });
    }

    // verifying radio inputs //
    var radioGroups = step.querySelectorAll("div.gum-radio-group");

    if (radioGroups != null) {
      radioGroups.forEach(function (radioGroup) {
        var checkedRadio = radioGroup.querySelector("input[type='radio']:checked, input[type='checkbox']:checked");

        if (checkedRadio == null) {
          if (!radioGroup.classList.contains('gum-checkbox-image-group')) {
            radioGroup.classList.add("gum-error");
            errorCount++;
          }
        } else {
          var inputsAreRadios = checkedRadio.type == "radio";

          if (inputsAreRadios) GUMForm.data[checkedRadio.name] = checkedRadio.value;

          else {
            var values = "";

            radioGroup.querySelectorAll("input[type='checkbox']:checked").forEach(function (element) {
              values += element.value + ",";
            });

            values = values.slice(0, -1); // removing last comma

            GUMForm.data[checkedRadio.name] = values;
          }
          radioGroup.classList.remove("gum-error");
        }
      })
    }

    // verifying checkboxes
    var checkboxGroups = step.querySelectorAll("div.gum-checkbox-group");

    if (checkboxGroups != null) {
        checkboxGroups.forEach(function (checkboxGroup) {
            var checkedCheckbox = checkboxGroup.querySelector("input[type='checkbox']:checked");
            if (checkedCheckbox) {
                var values = "";
                checkboxGroup.querySelectorAll("input[type='checkbox']:checked").forEach(function (element) {
                    values += element.value + ",";
                });
                values = values.slice(0, -1); // removing last comma
                GUMForm.data[checkedCheckbox.name] = values;
            }
        })
    }

    // verifying selects
    var elements = step.querySelectorAll("select");

    if (elements != null) {
      elements.forEach(function (element) {
        if (element.value == "__gum-empty__") {
          element.classList.add("gum-error");
          errorCount++;
        } else {
          GUMForm.data[element.name] = element.value;
          element.classList.remove("gum-error");
        }
      });
    }

    // verifying policy
    var policyContainer = step.querySelector("div.gum-policy");

    if (policyContainer != null) {
      if (!policyContainer.querySelector("input").checked) {
        policyContainer.classList.add("gum-error");
        errorCount++;
      } else
        policyContainer.classList.remove("gum-error");
    }

    var dayInputs = step.querySelectorAll("[name='gum-day']");

    dayInputs.forEach(function (dayInput) {
      var dateInput = dayInput.parentElement,
          fieldName = dateInput.getAttribute("name");

      var day = dateInput.querySelector("[name='gum-day']").value,
          month = dateInput.querySelector("[name='gum-month']").value;

      GUMForm.data[fieldName] = (day.length < 2 ? "0" : "") + day + "/" +
          (month.length < 2 ? "0" : "") + month + "/" +
          dateInput.querySelector("[name='gum-year']").value;
    });

    var newsOptin = step.querySelector('[name="newsoptin"]'),
        partnersoptin = document.querySelector('[name="partnersoptin"]'),
        newspartnersoptinYes = document.getElementById('newspartnersoptin-yes');

    if (newsOptin != null) {
      GUMForm.data["newsoptin"] = newsOptin.checked;
    }

    if (partnersoptin != null) {
      GUMForm.data["partnersoptin"] = partnersoptin.checked;
    }
    if (newspartnersoptinYes !== null) {
      GUMForm.data["newsoptin"] = newspartnersoptinYes.checked;
      GUMForm.data["partnersoptin"] = newspartnersoptinYes.checked;
    }

    return errorCount == 0;
  },

  showSuccess : function(step, form)
  {
    step.classList.add("gum-hidden");
    form.querySelector("div.gum-success-message").classList.remove("gum-hidden");

    var aff_id = document.querySelector("[name='aff_id']").value, aff_sub5 = document.querySelector("[name='aff_sub5']").value;

    if(aff_sub5 != null && aff_sub5 != "")
    {
      fbq("init", aff_sub5);
      fbq("track", "Lead");
    }

    if(aff_id != null && aff_id != "")
    {
      if(GUMForm.tracking != undefined)
      {
        var i;

        for(i = 0; i < GUMForm.tracking.length; i++)
        {
          var pixel = GUMForm.tracking[i];

          if(pixel.affiliate_id == aff_id && pixel.step == "lead")
          {
            if(pixel.type == "html")
            {
              var element = document.createElement("div");
              element.style.display = "none";
              element.innerHTML = pixel.code;
              document.body.appendChild(element);
            }

            else if(pixel.type == "js")
            {
              eval(pixel.code);
            }
          }
        }
      }
    }
    if (typeof customSuccessFunction === 'function') {
      customSuccessFunction()
    }

    var form_id = new URLSearchParams(window.location.search).get("form_id");

    if(GUMForm.upsell_is_allowed)
    {
      var request = new XMLHttpRequest();
      request.open("POST", "https://" + GUMForm.baseApiUrl + "/leads/lead/upsell?source=formjs", true);
      request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

      request.onload = function()
      {
        var data = JSON.parse(request.responseText);

        // if there is an upsell page available
        if(data["upsell"] != null && !GUMForm.noRedirect) {
          var URLPath = GUMForm.thank_you_path + "?data=" + Base64.encode(JSON.stringify(GUMForm.data))

          // Fetch the invisible form and its hidden data field
          var invisibleForm = document.getElementById("gum-upsell-form")
          var hiddenDataField = invisibleForm.querySelector("input[name='data']")

          // Assign the base64 encoded form data to the hidden "data" field
          hiddenDataField.value = Base64.encode(JSON.stringify(GUMForm.data))

          if (GUMForm.isDivi) {
            var parentDomain = new URLSearchParams(parent.window.location).get("hostname");
            parentDomain = parentDomain.replace('page.', '')
            // can happen
            // e.g this page is considered as Divi because it has no parent_domain parameter:
            // https://devis-en-ligne.io/aides-solaire-2022/?region=%C3%8Ele-de-France&click_id=1022c93e81341c127a41978cdc6044&aff_id=17146&offer_id=25771&aff_sub=17146_25771&aff_sub5=&creator_id=623&aff_sub_id=&source=
            if (parentDomain.indexOf("landing.") === -1) {
              parentDomain = "landing." + parentDomain;
            }
            if (parentDomain.startsWith("http://")) {
              parentDomain = parentDomain.replace("http://", "")
            } else if (parentDomain.startsWith("https://")) {
              parentDomain = parentDomain.replace("https://", "")
            }
            if (parent.window.location.href.includes('thank-you')) {
              parent.window.location.href = "https://" + parentDomain + URLPath
            } else {
              // Submit the invisible form
              invisibleForm.action = "https://" + parentDomain + URLPath
              invisibleForm.submit()
            }
          } else {
            var parentDomain = new URL(window.location.href).searchParams.get("parent_domain")

            // if no parent domain, form is directly in the page and not in an iframe, working directly with actual page url
            if (parentDomain == null) parentDomain = new URL(window.location.href).origin

            parentDomain = parentDomain.replace(/(news\.|presupuesto\.|deals\.|simulation\.|ofertas\.|test\.|page\.)/g, "landing.")

            if (parentDomain === 'https://www.1devis.io') {
              parentDomain = 'https://landing.1devis.io'
            }
            if (parentDomain === 'https://www.ecoformations.com') {
              parentDomain = ' https://landing.ecoformations.com'
            }
            if (parentDomain === 'https://www.devis-en-ligne.io') {
              parentDomain = 'https://landing.devis-en-ligne.io'
            }
            if (parentDomain === 'https://edfenr.eco-astuce.com') {
              parentDomain = 'https://landing.eco-astuce.com'
            }
            if (parentDomain === 'https://topconcours.net') {
              parentDomain = 'https://landing.topconcours.net'
            }
            if (parentDomain === 'https://www.mon-forfait-internet.com') {
              parentDomain = 'https://landing.mon-forfait-internet.com'
            }

            parent.postMessage(JSON.stringify({ type: 'upsell', basedData: Base64.encode(JSON.stringify(GUMForm.data)) , url: parentDomain + URLPath }), GUMForm.parentDomain);
          }
        }
      }

      request.send(new URLSearchParams(GUMForm.data).toString());
    }
  },

  updateProgressBar : function()
  {
    var progressBar = GUMForm.form.querySelector("div.gum-progress-bar");

    if(progressBar != null)
    {
      var progressBox = progressBar.querySelector("div.gum-progress"),
          percentage = ((GUMForm.currentStep + 1) / GUMForm.stepCount) * 100;

      progressBar.querySelector("span.gum-percentage").innerHTML = Math.round(percentage) + "%";
      progressBox.style.width = percentage + "%";
    }
  },

  select: function(radioButton) {
    var radioGroup = radioButton.parentElement,
        step = radioGroup.closest("div.gum-step")
    var inputs = radioGroup.querySelectorAll("div.gum-radio input[type='radio'], div.gum-radio input[type='checkbox']");
    var inputsAreRadios = inputs[0].type == "radio";
    // if radios, reset all states before checking input
    if(inputsAreRadios)
    {
      // functional
      inputs.forEach(function(element){element.checked = false});
      radioButton.querySelector("input").checked = true;

      // visual
      radioGroup.querySelectorAll("div.gum-radio").forEach(function(element){element.classList.remove("gum-selected")});
      radioButton.classList.add("gum-selected");
    }
    else
    {
      radioButton.classList.toggle("gum-selected");
      radioButton.querySelector("input").checked = !radioButton.querySelector("input").checked;
    }
    // automatically go to next step when a choice is made
    // makes sense only for radio, as for checkbox we don't know when the user has finished choosing
    if(inputsAreRadios && !GUMForm.editIsActive)
    {
      /* when generating the HTML code, we use onmousedown instead of onclick on div.gum-radio,
         otherwise the following line triggers sometimes the onclick event, resulting in going in GUMForm.select twice !! */
      var radioGroupCount = step.querySelectorAll("div.gum-radio-group").length,
          checkedRadioCount = step.querySelectorAll("div.gum-radio input[type='radio']:checked").length;
      if(GUMForm.stepCount > 1 && radioGroupCount == checkedRadioCount)
      {
          GUMForm.next(radioButton);
      }
    }
  },

  previous : function(button)
  {
    var form = button.closest("div.gum-form"), step = button.closest("div.gum-step");

    form.querySelectorAll("div.gum-step").forEach(function(element){element.classList.add("gum-hidden")});
    step.previousSibling.classList.remove("gum-hidden");
    step.previousSibling.classList.remove("gum-finished");
    if (step.querySelector("div.gum-positive-message")) {
        step.querySelector("div.gum-positive-message").innerHTML = ""
        step.previousSibling.querySelector("div.gum-positive-message").innerHTML = "";
    }
    if (step.querySelector("div.gum-error-message")) {
        step.querySelector("div.gum-error-message").innerHTML = "";
        step.previousSibling.querySelector("div.gum-error-message").innerHTML = "";
    }
    let smsVerification = step.querySelector("#sms_verification")
    if (smsVerification) smsVerification.value = ""
    GUMForm.resizeParentIframe(step.previousSibling);

    GUMForm.currentStep--;
    GUMForm.updateProgressBar();
  },

  next: async function (button) {
    var form = button.closest('div.gum-form'),
        step = button.closest('div.gum-step'),
        phoneElement = step.querySelector('#phone_with_code_verification'),
        codeElement = step.querySelector('#sms_verification'),
        summary = form.querySelector('.gum-summary'),
        steps = form.querySelectorAll('div.gum-step')

    if(GUMForm.isValid(step)) {
      if (phoneElement && !await GUMForm.verifyPhoneNumber(phoneElement, step, button)) return;
      if (codeElement && !await GUMForm.validateVerificationCode(button)) return;

      GUMForm.createTimeDiv(step)

      if (step.nextSibling) {
        GUMForm.replacePlaceholders(step.nextSibling);
      }

      var selectedOption = step.querySelector('input[type="radio"]:checked');
      var selectedStepId = selectedOption ? selectedOption.dataset.target : null;

      var wholeStepTargetId = step.dataset.target

      steps.forEach((step) => step.classList.add("gum-hidden"));
      step.classList.add("gum-finished")

      let nextStep
      if (phoneElement && GUMForm.phoneVerified) {
        nextStep = step.nextSibling.nextSibling
      } else if (selectedStepId) {
        nextStep = document.getElementById(selectedStepId);
      } else if (wholeStepTargetId) {
        nextStep = document.getElementById(wholeStepTargetId)
      } else {
        if (summary) {
          GUMForm.addSummary(form, step, GUMForm.currentStep)
        }
        if (GUMForm.editIsActive) {
          nextStep = steps[steps.length - 1]
          button.parentElement.querySelectorAll('.gum-button').forEach((button) => button.classList.remove('d-none'))
          button.parentElement.querySelector('.gum-button-confirm').classList.add('d-none')
        } else {
          nextStep = step.nextSibling
        }
      }

      nextStep.classList.remove('gum-hidden')
      try {
        if (typeof ymID !== undefined && typeof ym === 'function') {
          let stepId = nextStep.id
          if (!stepId) {
            let titles = nextStep.getElementsByClassName('gum-title')
            if (titles) {
              stepId = titles[0].innerText
            }
          }
          ym(ymID, 'reachGoal', 'test-form-step', { step: stepId })
        }
      } catch (e) {

      }
      if (nextStep.classList.contains('gum-no-fields')) {
        setTimeout(() => { GUMForm.chatEmptyStepNext(nextStep) }, 1500)
      }
      GUMForm.editIsActive ? (GUMForm.currentStep = GUMForm.stepCount - 1) : GUMForm.currentStep++;
      GUMForm.editIsActive = false
      GUMForm.updateProgressBar();
      GUMForm.resizeParentIframe(step.nextSibling);
    }
  },

  getParentIframe : function()
  {
    var iframes = parent.document.querySelectorAll("iframe"), parentIframe = null, i;

    for(i = 0; i < iframes.length && parentIframe == null; i++)
    {
      var iframe = iframes[i];

      // if the current iframe src contains gum-form, it means it's the form iframe we were looking for
      if(iframe.src.indexOf("gum-form") != -1)
      {
        // if iframe has id, it means it's in upsell page, where we can have several forms
        if(iframe.id != "")
        {
          if(iframe.id == "gum-form-" + GUMForm.id) parentIframe = iframe;
        }

        // if there is no id, it means we are outside of upsell page, where there is always only 1 form
        else
          parentIframe = iframe;
      }
    }

    return parentIframe;
  },

  resizeParentIframe: function(step) {
    try {
      var progressBarHeight = GUMForm.form.querySelector("div.gum-progress-bar") ? GUMForm.form.querySelector("div.gum-progress-bar").offsetHeight : 0
      if(GUMForm.isDivi) {
        var parentIframe = GUMForm.getParentIframe()
        if (parentIframe != null) {
          parentIframe.style.height = (progressBarHeight + step.offsetHeight) + "px"
        }
      } else if (GUMForm.parentDomain) {
        var newHeight = (progressBarHeight + step.offsetHeight) + "px"
        parent.postMessage(JSON.stringify({ type: 'height', height: newHeight }), GUMForm.parentDomain)
      }
    } catch(error) {
      console.error("Error resizing parent iframe:", error)
    }
  },

  allowSending : function()
  {
    try {
      let officeFlag = document.getElementById('gum-main-form').getAttribute('data-office')
      return window.localStorage.getItem("_GUMSentLeadForm_" + GUMForm.id) == null || GUMForm.data.last_name.toLowerCase() === "test" || officeFlag === '1';
    } catch (e) {
      return true
    }
  },

  send : function(button, event)
  {
    event.preventDefault()

    var form = button.closest("div.gum-form"), step = button.closest("div.gum-step"), hiddens = form.querySelector("div.gum-hiddens").querySelectorAll("[type=hidden]");

    hiddens.forEach(function(input)
      {
        // data from gum_data is get from PHP (encoded data to bypass ad blockers), then output in hiddens
        // we need to transfer this data from the DOM to the JS object in order to send to the API,
        // but we have to do it only for fields which are ONLY in hiddens, and not somewhere in the form too

        if(form.querySelectorAll('div.gum-step [name="' + input.name + '"]').length == 0)
          GUMForm.data[input.name] = input.value;
      });

    GUMForm.data["country"] = form.getAttribute("gum-country");
    GUMForm.data["time_on_page"] = Math.round((Date.now() - GUMForm.startTime) / 1000);

    if(GUMForm.isValid(step))
    {
      grecaptcha.ready(function() {
        grecaptcha.execute('6LfxOgUqAAAAACIXjfwxUFn97Opku7ilATC7cnlA', {action: 'submit'})
            .then(token => GUMForm.verifyRecaptcha(token))
            .then(() => {
              if(GUMForm.isSending) return
              GUMForm.isSending = true
              button.disabled = true
              // allowSending needs last_name, so it needs to come after isValid, because isValid fills the data array
              if(GUMForm.allowSending())
              {
                if(GUMForm.excluded_clients) GUMForm.data["excluded_clients"] = GUMForm.excluded_clients;

                if (document.getElementById('xxTrustedFormToken_0') !== null) {
                  try {
                    GUMForm.data['xxTrustedFormToken'] = document.getElementById('xxTrustedFormToken_0').value
                    GUMForm.data['xxTrustedFormCertUrl'] = document.getElementById('xxTrustedFormCertUrl_0').value
                    GUMForm.data['xxTrustedFormPingUrl'] = document.getElementById('xxTrustedFormPingUrl_0').value
                  } catch (e) {
                  }
                }

                if (document.querySelector('[name="lg-certid"]') !== null) {
                  try {
                    GUMForm.data['lg-certid'] = document.querySelector('[name="lg-certid"]').value
                    GUMForm.data['lg-link'] = document.querySelector('[name="lg-link"]').value
                    GUMForm.data['lg-sessid'] = document.querySelector('[name="lg-sessid"]').value
                  } catch (e) {
                  }
                }
                try {
                  if (typeof ymID !== undefined && typeof ym === 'function') {
                    ym(ymID, 'reachGoal', 'test-form-step', { step: 'thank-you-message' })
                  }
                } catch (e) {

                }
                button.innerHTML = form.getAttribute("gum-loading-message");
                button.value = form.getAttribute("gum-loading-message");
                var request = new XMLHttpRequest();
                request.open("POST", "https://" + GUMForm.baseApiUrl + "/leads/lead", true);
                request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

                request.onload = function()
                {
                  GUMForm.isSending = false
                  button.disabled = false
                  try {
                    window.localStorage.setItem("_GUMSentLeadForm_" + GUMForm.id, "true");
                  } catch (e) {}

                  if(GUMForm.redirection_url != '' && !GUMForm.noRedirect)
                  {
                    if(GUMForm.isDivi)
                      parent.window.location = GUMForm.redirection_url;

                    else
                      parent.postMessage(JSON.stringify({ type: 'redirect', url: GUMForm.redirection_url }), GUMForm.parentDomain);
                  }

                  else {
                    GUMForm.showSuccess(step, form)
                    step.classList.add("gum-finished")
                    GUMForm.createTimeDiv(step)
                  }
                }

                request.send(new URLSearchParams(GUMForm.data).toString());
              }
              else
              {
                button.innerHTML = "Lead already sent.";
                button.value = "Lead already sent.";
              }
            })
      })
    }
  },

  createTimeDiv: function(step) {
    let now = new Date();
    let timeDiv = step.querySelectorAll('.gum-answer-time')
    if (timeDiv) {
      //This will create format like 09:00 instead of 9:0
      let hours = now.getHours().toString();
      let minutes = now.getMinutes().toString();
      timeDiv.forEach((element)=>{
        element.innerHTML = hours.padStart(2, '0') + ':' + minutes.padStart(2, '0');
      })
    }
  },

  handleZipAndCitySuggestion : function(event)
  {
    // for now only works for France
    if(this.value.length > 2 && event.keyCode != 13 && event.keyCode != 27)
    {
      var $this = this,
          suggestionElement = $this.parentElement.querySelector("div.gum-suggestion");

      suggestionElement.innerHTML = "&nbsp;&nbsp;...&nbsp;&nbsp;";

      var request = new XMLHttpRequest();
      request.addEventListener("load",
        function()
        {
          var options = "<ul>", data = JSON.parse(this.responseText);

          suggestionElement.classList.add("visible");

          for(var i = 0; i < data.length; i++)
          {
            options += "<li onclick='GUMForm.fillZipAndCity(\"" + data[i].zip + "\", \"" + data[i].city + "\")'>" + data[i].zip + ", " + data[i].city + "</li>";
          }

          options += "</ul>";

          suggestionElement.innerHTML = options;
        });

      var requestURL = this.name == "city" ? "https://form." + GUMForm.baseApiDomain + "/common/gum-form/gum-geo-api.php?type=city&query=" + this.value + "&country=fr"
                                           : "https://form." + GUMForm.baseApiDomain + "/common/gum-form/gum-geo-api.php?type=zip&query=" + this.value + "&country=fr";

      request.open("GET", requestURL);
      request.send();
    }

    else if(event.keyCode == 13 || event.keyCode == 27)
     GUMForm.hideSuggestionDropdowns();
  },

  fillZipAndCity : function(zip, city)
  {
    var zipField = document.querySelector("[name='zip']"), cityField = document.querySelector("[name='city']");

    if(zipField != null) zipField.value = zip;
    if(cityField != null) cityField.value = city;

    GUMForm.hideSuggestionDropdowns();
  },

  verifyPhone : async function(phoneNumber) {
    try {
      const response = await fetch('https://phone.' + GUMForm.baseApiDomain + '/code/create', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
        },
        body: JSON.stringify({
          phone: phoneNumber,
          landing_name: GUMForm.landingName,
        }),
      });
      if (response.status === 204) {
        return { code: 204, message: GUMForm.getTranslatedMessage("code_sent") }
      }
      if (response.status === 200) {
        const data = await response.json();
        return { code: 200, message: GUMForm.getTranslatedMessage(data.message) }
      }
      if (response.status === 422) {
        const data = await response.json();
        return { code: 422, message: GUMForm.getTranslatedMessage(data.message) }
      }
      if (response.status === 500) {
        return { code: 500, message: GUMForm.getTranslatedMessage("server_error") }
      }
    } catch (error) {
      console.error('Phone verification failed:', error);
      return { error: "Verification failed, please try again." };
    }
  },

  verifyPhoneNumber: async function(phoneElement,step,button) {
    GUMForm.phoneNumber = GUMForm.addCountryPrefix(phoneElement.value)
    let verificationResult = await GUMForm.verifyPhone(GUMForm.phoneNumber)
    if (verificationResult.code === 204) {
      step.querySelector('.gum-positive-message').innerHTML = verificationResult.message
      step.querySelector('.gum-error-message').innerHTML = '';
      button.disabled = true;
      await new Promise(resolve => setTimeout(resolve, 2000));
      button.disabled = false;
      return true
    }
    else if (verificationResult.code === 200) {
      GUMForm.phoneVerified = true;
      step.querySelector('.gum-positive-message').innerHTML = verificationResult.message
      step.querySelector('.gum-error-message').innerHTML = '';
      button.disabled = true;
      await new Promise(resolve => setTimeout(resolve, 2000));
      button.disabled = false;
      return true
    }
    else if(verificationResult.code !== 204 && verificationResult.code !== 200) {
      step.querySelector('.gum-error-message').innerHTML = verificationResult.message
      step.querySelector('.gum-positive-message').innerHTML = '';
      return false
    }
  },

  verifyCode: async function(code,phoneNumber) {
    try {
      const response = await fetch('https://phone.' + GUMForm.baseApiDomain + '/code/validate', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
        },
        body: JSON.stringify({
          phone: phoneNumber,
          code: code
        }),
      });
      if (response.status === 204) {
        return { code: 204, message: GUMForm.getTranslatedMessage("code_sent") }
      }
      if (response.status === 200) {
        const data = await response.json();
        return { code: 200, message: GUMForm.getTranslatedMessage(data.message) }
      }
      if (response.status === 422) {
        const data = await response.json();
        return { code: 422, message: GUMForm.getTranslatedMessage(data.message) }
      }
    } catch (error) {
      console.error('Phone verification failed:', error);
      return { error: "Verification failed, please try again." };
    }
  },

  validateVerificationCode: async function(button) {
    let step = button.closest("div.gum-step");
    let codeElement = step.querySelector("#sms_verification")
    if(codeElement) {
      let verificationCodeResult = await GUMForm.verifyCode(codeElement.value, GUMForm.phoneNumber)
      if (verificationCodeResult.code === 422) {
        step.querySelector('.gum-error-message').innerHTML = verificationCodeResult.message;
        step.querySelector('.gum-positive-message').innerHTML = '';
        button.disabled = true;
        await new Promise(resolve => setTimeout(resolve, 2000));
        button.disabled = false;
        return false
      }
      else if (verificationCodeResult.code === 200) {
        step.querySelector('.gum-positive-message').innerHTML = verificationCodeResult.message;
        step.querySelector('.gum-error-message').innerHTML = '';
        button.disabled = true;
        await new Promise(resolve => setTimeout(resolve, 2000));
        button.disabled = false;
        return true; // Allow form submission
      }
      // Handle server error
      else if (verificationCodeResult.code === 500) {
        step.querySelector('.gum-error-message').innerHTML = "Server error, please try again later.";
        step.querySelector('.gum-positive-message').innerHTML = '';
        button.disabled = true;
        await new Promise(resolve => setTimeout(resolve, 2000));
        button.disabled = false;
        return false; // Stop form submission
      }
    }
  },

  addCountryPrefix(phoneNumber) {
    const countryCodes = {
      "fr": "+33",
      "es": "+34",
      "de": "+49",
      "pt": "+351",
      "it": "+39",
      "gb": "+44",
      "us": "+1",
      "au": "+61",
      "ch": "+41"
    }
    const countryCode = countryCodes[GUMForm.country] || ""

    if (!phoneNumber.startsWith(countryCode)) return countryCode + phoneNumber.replace(/^0+/, '')
    return phoneNumber
  },

  getTranslatedMessage : function(messageKey) {
    return GUMForm.translations[messageKey]?.[GUMForm.country] || messageKey;
  },
  hideSuggestionDropdowns : function()
  {
    document.querySelectorAll("div.gum-suggestion").forEach(function(element) {element.classList.remove("visible") });
  },

  addSummary: function(form, step, currentStep) {
    let summaryElement = form.querySelector('.gum-summary'),
        fields = step.querySelectorAll('.gum-field'),
        stepSummaryId = `summary-step-${currentStep}`,
        stepSummaryElement = document.getElementById(stepSummaryId) || document.createElement('div');

    stepSummaryElement.id = stepSummaryId;
    stepSummaryElement.innerHTML = '';

    fields.forEach((field) => {
      let gumInput = field.querySelector('.gum-input'),
          input = gumInput.querySelector('input'),
          fieldValue = '';
      if (input) {
        if (GUMForm.contact_fields.includes(input.name)) {
          fieldValue = input.value || ''
          stepSummaryElement.innerHTML += `
            <div class="summary-item">
              <span class="summary-text">${fieldValue}</span>
              <button class="summary-edit" onclick="GUMForm.editRecapElement(this, ${currentStep},form)" type="button">
                ${GUMForm.getTranslatedMessage('edit')}
              </button>
            </div>
           `
          let nextStepSummaryElement = document.getElementById(`summary-step-${currentStep}`);
          if (nextStepSummaryElement) {
            summaryElement.replaceChild(stepSummaryElement, nextStepSummaryElement);
          } else {
            summaryElement.appendChild(stepSummaryElement);
          }
        }
      }
    })
  },

  editRecapElement: function(element, currentStep, form) {
    GUMForm.currentStep = currentStep;
    GUMForm.editIsActive = true
    let steps = form.querySelectorAll("div.gum-step")
    steps.forEach((step) => step.classList.add("gum-hidden"))
    steps[currentStep].classList.remove("gum-hidden")
    steps[currentStep].querySelector('.gum-button-group').querySelectorAll('.gum-button').forEach((button) => button.classList.add('d-none'))
    steps[currentStep].querySelector('.gum-button-group').querySelector('.gum-button-confirm').classList.remove('d-none')
  },

  showMatchingDropdown : function(dropdown)
  {
    var name = dropdown.name,
        targetDropdown = document.querySelector('[name="' + dropdown.getAttribute("gum-target") + '"]'),
        list = dropdown.options[dropdown.selectedIndex].getAttribute("gum-list").split(/\,\,/g);

    var options = '<option value="__gum-empty__" selected disabled>' + dropdown.value + ' ↓</option>';

    for(var i = 0; i < list.length; i++)
    {
      options += '<option value="' + list[i] + '">' + list[i] + '</option>';
    }

    targetDropdown.innerHTML = options;
  },

  showPartnersPopup : function()
  {
    document.querySelector("div.gum-overlay").style.display = "block";
  },

  hidePartnersPopup : function()
  {
    document.querySelector("div.gum-overlay").style.display = "none";
  },

  updatePartner : function(partner_id, input)
  {
    if(!input.checked) GUMForm.excluded_clients.push(partner_id);

    else
    {
      var index = GUMForm.excluded_clients.indexOf(partner_id);

      if(index > -1) GUMForm.excluded_clients.splice(index, 1);
    }
  },

  verifyRecaptcha : function(token) {
    return fetch('https://form.' + GUMForm.baseApiDomain + "/common/gum-captcha/index.php", {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify({
        token: token,
      }),
    })
        .then(response => response.json())
        .then(data => GUMForm.data["captcha_score"] = data.score)
        .catch(error => {
          console.error('Error:', error)
          GUMForm.data["captcha_score"] = 0
        })
  },

  replacePlaceholders: function(step) {
    var elements = step.querySelectorAll("*:not(script):not(style)")
    elements.forEach(node => {
      if (node.childNodes.length) {
        node.childNodes.forEach(child => {
          if (child.nodeType === 3) {
            child.nodeValue = child.nodeValue.replace(/\{\{(.*?)\}\}/g, function(match, placeholder) {
              var replacement = GUMForm.data[placeholder.trim()]
              return replacement || match
            })
          }
        })
      }
    })
  },

  chatEmptyStepNext: function(step) {
    var form = step.closest('div.gum-form'),
        steps = form.querySelectorAll('div.gum-step'),
        currentStep = Array.from(steps).indexOf(step),
        nextStep = steps[currentStep + 1]

    step.classList.add('gum-finished')
    steps.forEach((step) => step.classList.add('gum-hidden'))
    nextStep.classList.remove('gum-hidden')
    if (nextStep.classList.contains('gum-no-fields')) {
      setTimeout(() => { GUMForm.chatEmptyStepNext(nextStep) }, 1500)
    }
  },

  initialise : function()
  {
    var parent_domain = new URLSearchParams(window.location.search).get("parent_domain"),
        parent_path = new URLSearchParams(window.location.search).get("parent_path"),
        no_redirect = new URLSearchParams(window.location.search).get("no_redirect");

    GUMForm.baseApiDomain = BASE_API_DOMAIN;
    GUMForm.baseApiUrl = BASE_API_URL;
    GUMForm.parentDomain = parent_domain;
    GUMForm.parentPath = parent_path;
    GUMForm.parentDomainAndPath = parent_domain + parent_path;
    GUMForm.isDivi = (parent_domain == null || parent_domain == "") && !window.location.href.match(/:\/\/(test\.)/g); // test. pages doesn't have parent domain parameter but are not divi
    GUMForm.noRedirect = no_redirect === '1'
    GUMForm.form = document.getElementById("gum-main-form").querySelector("div.gum-form");
    GUMForm.stepCount = GUMForm.form.querySelectorAll("div.gum-step").length;
    GUMForm.isTestEnvironment = TEST_ENV_ON;
    GUMForm.landingName = document.querySelector("[name='landing_name']").value
    GUMForm.country = GUMForm.form.getAttribute("gum-country");

    GUMForm.updateProgressBar();
    GUMForm.resizeParentIframe(GUMForm.form.querySelectorAll("div.gum-step")[0]);
    GUMForm.startTime = Date.now();

    // prefillable fields

    var fields = ["first_name", "last_name", "email", "phone"], i;

    for(i = 0; i < fields.length; i++)
    {
      name = fields[i];
      formField = document.querySelector("div.gum-field [name='" + name + "']");
      hiddenField = document.querySelector("div.gum-hiddens [name='" + name + "']");

      if(hiddenField != null)
      {
        if(hiddenField.value != "")
        {
          formField.value = hiddenField.value;
        }
      }
    }

    if (!GUMForm.form.querySelector("div.gum-hiddens [name='user_agent']")) {
      var gumHiddensDiv = GUMForm.form.querySelector("div.gum-hiddens"),
          userAgentField = document.createElement('input')

      userAgentField.type = 'hidden'
      userAgentField.name = 'user_agent'
      userAgentField.value = window.navigator.userAgent

      gumHiddensDiv && gumHiddensDiv.appendChild(userAgentField)
    }

    if(GUMForm.form.getAttribute("gum-country") == "fr")
    {
      document.querySelectorAll("[name='zip'],[name='city']").forEach(function(element)
        {
          if(element != null)
          {
            if(element.type != "hidden")
            {
              // element.addEventListener("keyup", GUMForm.handleZipAndCitySuggestion);
              // element.addEventListener("focus", GUMForm.handleZipAndCitySuggestion);
            }
          }
        });

      document.body.addEventListener("click", function(event)
        {
          var targetIsInsideSuggestion = false;

          document.querySelectorAll("div.gum-suggestion").forEach(function(element) { if(element.contains(event.target)) targetIsInsideSuggestion = true });

          if(!event.target.classList.contains("gum-suggestion") && !targetIsInsideSuggestion) GUMForm.hideSuggestionDropdowns();
        });
    }

    var form = document.getElementById("gum-main-form").querySelector("div.gum-form");
    var inputs = form.querySelectorAll("div.gum-field input");
    inputs.forEach(function(input) {
      input.addEventListener('keypress', function(event) {
        if (event.keyCode === 13) {
          event.preventDefault();
        }
      })
    })

    // initialize chatbot empty step if is in the first step
    let steps = form.querySelectorAll("div.gum-step")
    if (steps[0].classList.contains('gum-no-fields')) GUMForm.chatEmptyStepNext(steps[0])
  }
};

window.addEventListener("load", GUMForm.initialise);
